/*************************************************************************************
 *
 * Generated on Thu Jan 10 09:46:29 CET 2013 by Spray ToolBehaviorProvider.xtend
 *
 * This file contains generated and should not be changed.
 * Use the extension point class (the direct subclass of this class) to add manual code
 *
 *************************************************************************************/
package edu.kit.ipd.descartes.mm.applicationlevel.repository.compositediagram.diagram;

import org.eclipse.graphiti.dt.IDiagramTypeProvider;
import org.eclipse.graphiti.features.IFeature;
import org.eclipse.graphiti.palette.IPaletteCompartmentEntry;
import org.eclipselabs.spray.runtime.graphiti.layout.SprayLayoutService;
import org.eclipselabs.spray.runtime.graphiti.tb.AbstractSprayToolBehaviorProvider;
import org.eclipse.graphiti.mm.algorithms.GraphicsAlgorithm;
import org.eclipse.graphiti.mm.pictograms.PictogramElement;
import org.eclipse.graphiti.mm.pictograms.ContainerShape;
import org.eclipse.emf.common.util.EList;
import org.eclipse.graphiti.services.Graphiti;

import com.google.common.collect.Lists;
import edu.kit.ipd.descartes.mm.applicationlevel.repository.compositediagram.features.CompositediagramCreateAssemblyContextFeature;
import edu.kit.ipd.descartes.mm.applicationlevel.repository.compositediagram.features.CompositediagramCreateCompositeComponentFeature;

public abstract class CompositediagramToolBehaviorProviderBase extends AbstractSprayToolBehaviorProvider {
    protected static final String COMPARTMENT_CONTEXT    = "Context";
    protected static final String COMPARTMENT_COMPONENTS = "Components";

    public CompositediagramToolBehaviorProviderBase(final IDiagramTypeProvider dtp) {
        super(dtp);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public GraphicsAlgorithm getSelectionBorder(PictogramElement pe) {
        boolean isFromDsl = SprayLayoutService.isShapeFromDsl(pe);
        if (isFromDsl) {
            ContainerShape container = (ContainerShape) pe;
            if (!container.getChildren().isEmpty()) {
                return container.getChildren().get(0).getGraphicsAlgorithm();
            }
        }
        return super.getSelectionBorder(pe);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    protected void buildCreationTools() {
        buildCreationTool(new CompositediagramCreateCompositeComponentFeature(this.getFeatureProvider()));
        buildCreationTool(new CompositediagramCreateAssemblyContextFeature(this.getFeatureProvider()));
        // Compartments
    }

    /**
     * {@inheritDoc}
     */
    @Override
    protected Iterable<IPaletteCompartmentEntry> buildPaletteCompartments() {
        return Lists.newArrayList(getPaletteCompartment(COMPARTMENT_CONTEXT), getPaletteCompartment(COMPARTMENT_COMPONENTS), getPaletteCompartment(COMPARTMENT_DEFAULT));
    }

    /**
     * {@inheritDoc}
     */
    @Override
    protected IPaletteCompartmentEntry getPaletteCompartmentForFeature(final IFeature feature) {
        if (feature instanceof CompositediagramCreateCompositeComponentFeature) {
            return getPaletteCompartment(COMPARTMENT_COMPONENTS);
        } else if (feature instanceof CompositediagramCreateAssemblyContextFeature) {
            return getPaletteCompartment(COMPARTMENT_CONTEXT);
        }
        return super.getPaletteCompartmentForFeature(feature);
    }
}
