/*************************************************************************************
 *
 * Generated on Thu Jan 10 09:46:29 CET 2013 by Spray MoveFeature.xtend
 *
 * This file contains generated and should not be changed.
 * Use the extension point class (the direct subclass of this class) to add manual code
 *
 *************************************************************************************/
package edu.kit.ipd.descartes.mm.applicationlevel.repository.compositediagram.features;

import org.eclipse.graphiti.features.IFeatureProvider;
import org.eclipse.graphiti.features.IRemoveFeature;
import org.eclipse.graphiti.features.context.IMoveShapeContext;
import org.eclipse.graphiti.features.impl.DefaultMoveShapeFeature;
import org.eclipse.graphiti.features.context.impl.AddContext;
import org.eclipse.graphiti.features.context.impl.RemoveContext;
import org.eclipse.graphiti.mm.pictograms.PictogramElement;
import org.eclipse.graphiti.mm.pictograms.ContainerShape;
import org.eclipse.graphiti.mm.pictograms.Shape;

import org.eclipselabs.spray.runtime.graphiti.GraphitiProperties;
import org.eclipselabs.spray.runtime.graphiti.ISprayConstants;
import org.eclipselabs.spray.runtime.graphiti.layout.SprayLayoutService;
import org.eclipselabs.spray.runtime.graphiti.layout.SprayFixedLayoutManager;
import org.eclipselabs.spray.runtime.graphiti.layout.SprayTopLayoutManager;
import org.eclipselabs.spray.runtime.graphiti.layout.SprayDiagramLayoutManager;
import org.eclipselabs.spray.runtime.graphiti.shape.SprayLayoutManager;
import edu.kit.ipd.descartes.mm.applicationlevel.repository.compositediagram.shapes.RectShape;

import edu.kit.ipd.descartes.mm.applicationlevel.repository.AssemblyContext;
import edu.kit.ipd.descartes.mm.applicationlevel.repository.CompositeComponent;

public abstract class CompositediagramMoveAssemblyContextFeatureBase extends DefaultMoveShapeFeature {

    SprayLayoutManager layoutManager;

    public CompositediagramMoveAssemblyContextFeatureBase(final IFeatureProvider fp) {
        super(fp);
        layoutManager = new RectShape(fp).getShapeLayout();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public boolean canMoveShape(IMoveShapeContext context) {
        Shape sourceShape = (Shape) context.getPictogramElement();
        ContainerShape targetContainer = context.getTargetContainer();
        Object source = getBusinessObjectForPictogramElement(sourceShape);
        Object target = getBusinessObjectForPictogramElement(targetContainer);
        // check whether it can move in the same container
        if (sourceShape.eContainer() == targetContainer) {
            if ((SprayLayoutService.getLayoutManager(sourceShape.getContainer()) instanceof SprayFixedLayoutManager)) {
                return true;
            }
            if ((SprayLayoutService.getLayoutManager(sourceShape.getContainer()) instanceof SprayTopLayoutManager)) {
                return true;
            }
            if ((SprayLayoutService.getLayoutManager(sourceShape.getContainer()) instanceof SprayDiagramLayoutManager)) {
                return true;
            }
            return false;
        }
        // Can move from containment to another containment compartment
        if (target instanceof CompositeComponent) {
            if (SprayLayoutService.isCompartment(context.getTargetContainer())) {
                String id = GraphitiProperties.get(context.getTargetContainer(), ISprayConstants.TEXT_ID);
                if ((id != null) && (id.equals("context"))) {
                    return true;
                }
            }
        }
        return super.canMoveShape(context);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public void moveShape(IMoveShapeContext context) {
        PictogramElement sourceShape = context.getPictogramElement();
        ContainerShape targetContainer = context.getTargetContainer();
        ContainerShape sourceContainer = context.getSourceContainer();
        Object sourceParent = getBusinessObjectForPictogramElement(sourceContainer);
        Object source = getBusinessObjectForPictogramElement(sourceShape);
        Object target = getBusinessObjectForPictogramElement(targetContainer);
        if (sourceShape.eContainer() == targetContainer) {
            super.moveShape(context);
            return;
        }
        if (target instanceof CompositeComponent) {
            if (SprayLayoutService.isCompartment(targetContainer)) {
                String id = GraphitiProperties.get(targetContainer, ISprayConstants.TEXT_ID);
                if ((id != null) && (id.equals("context"))) {

                    sourceContainer.getChildren().remove(source);
                    ContainerShape sourceTop = SprayLayoutService.findTopDslShape(sourceContainer);
                    if (sourceTop != null) {
                        SprayLayoutService.getLayoutManager(sourceTop).layout();
                    }
                    // remove from source container and add to target container

                    ((CompositeComponent) target).getAssemblyContexts().add((AssemblyContext) source);
                    targetContainer.getChildren().add((Shape) sourceShape);
                    ContainerShape targetTop = SprayLayoutService.findTopDslShape(targetContainer);
                    if (targetTop != null) {
                        SprayLayoutService.getLayoutManager(targetTop).layout();
                    }
                    return;
                }
            }
        }
    }
}
